
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>进程默认堆和额外创建的堆 / 憋错料</title>

    <meta name="description" content="进程默认堆和额外创建的堆 在&lt;Windows核心编程&gt;第五版的第十八章 &lt;堆&gt; 中提到了进程默认堆和额外创建的堆.这在编程中是十分重要的知识,今天整理一下. 1,堆非常适合分配大量的小型数据.使用堆可以让程序员专心解决手头的问题,而不必理会分配粒度和页面边界之类的事情.因此堆是管理链表和数的最佳方式.但是堆进行内存分配和释放时的速度比其他方式都慢,而且无法对物理存储器的调拨和撤销调拨进行控制. 为了能适应各种硬件平台,如果程序员想要控制物理存储器的调拨和撤销调拨,就不应该使用堆,而应该使用虚拟内存 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">进程默认堆和额外创建的堆</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>在《Windows核心编程》第五版的第十八章 《堆》 中提到了进程默认堆和额外创建的堆。这在编程中是十分重要的知识，今天整理一下。</p>
<p>1，<strong>堆非常适合分配大量的小型数据</strong>。使用堆可以让程序员专心解决手头的问题，而不必理会分配粒度和页面边界之类的事情。因此<strong>堆是管理链表和数的最佳方式。</strong>但是堆进行内存分配和释放时的速度比其他方式都慢，而且无法对物理存储器的调拨和撤销调拨进行控制。</p>
<p>为了能适应各种硬件平台，如果程序员想要控制物理存储器的调拨和撤销调拨，就不应该使用堆，而应该使用虚拟内存（VirtualAlloc和VirtualFree）。</p>
<p>2.进程默认堆。</p>
<p>进程初始化时，系统会在进程的地址空间中创建一个堆。这个堆被称为进程的默认堆。默认情况下，这个堆的地址空间区域大小是1MB。程序员可以控制这个大小。我们可以在创建应用程序时用/HEAP连接器开关来改变默认堆的大小。由于DLL没有与之关联的堆，因此在创建DLL时，不应该使用/HEAP开关。</p>
<p>我们可以通过调用<strong>GetProcessHeap</strong>来得到进程默认堆</p>
<p>3.为什么要创建额外的堆？</p>
<p><strong>（1）对组件进行保护</strong></p>
<p>如：有一个链表和一个二叉树都需要保存在同一个堆中，这会使两种结构混合，假如链表中的某个节点出错覆盖他下边的某块内存，就可能把二叉树结构破坏，这会导致定位出错很难，于是把两种结构放到两个堆中，这种可能性就会小很多。</p>
<p><strong>（2）更有效的内存管理</strong></p>
<p>每个堆保证相同的结构会使内存分配更为合理。再举上一个例子，链表每个节点大小为24字节，二叉树每个节点32字节，现在链表释放了2个节点，这时有了48字节的空间，但是很有可能这两块内存不连续。而没法给二叉树分配一个节点的空间。如此操作，会使堆内内存碎片化。</p>
<p><strong>（3）使内存访问局部化</strong></p>
<p>我们知道系统在访问内存的时候会产生页交换，当系统把一个内存页换入到磁盘中，再从磁盘中换出一个内存页时，这种消耗是十分巨大的。于是，把相同的节点放在一个内存堆中就显得尤为重要了。继续举栗子，当我们一个堆中只保存链表节点，或者只保存二叉树节点，这个时候内存很有可能分配到邻近一块儿内存中，这时候我们遍历节点就不需要再进行页交换了。但是两个结构混用的话，很有可能看似相邻的两个节点其实在两个页交换文件中，如果运气差，有可能进行一次遍历，系统需要多次进行页交换，大大降低了效率。</p>
<p><strong>（4）避免线程同步的开销</strong></p>
<p>在默认情况下，系统中线程对堆的访问是依次进行的，如果你自己创建了堆，系统将不会用额外代码来保证线程的安全性，就会在一定程度上减小系统的消耗，不过这时候对堆的内存操作将有我们自己进行，系统将不再管理。</p>
<p><strong>（5）快速释放</strong></p>
<p>如果我们创建一个堆来存放数据，我们在销毁数据的时候可以仅仅将整个堆的内存释放，而不必一个个节点去释放，大大加快了释放内存的效率。</p>

<p>4.如何创建额外的堆</p>
<pre>HANDLE HeapCreate(

     DWORD fdwOptions,

     SIZE_T dwInitilialize,

     SIZE_T dwMaximumSize);</pre>
<p>5.堆创建后，需要从堆中分配内存时，要调用HeapAlloc函数：</p>
<pre>PVOID HeapAlloc(

     HANDLE hHeap,

     DWORD fdwFlags,

     SIZE_T dwBytes);</pre>
<p>如果分配成功HeapAlloc会返回内存块地址。否则将会返回NULL。</p>
<p>默认情况下，对堆的访问会依次进行。当任何程序试图从堆中分配一块内存时，HeapAlloc会执行以下操作：</p>
<p>1：遍历已分配的内存的链表和闲置内存的链表。</p>
<p>2：找到一块足够大的闲置内存块。</p>
<p>3：分配一块新的内存，将2找到的内存块标记为已分配。</p>
<p>4：将新分配的内存块添加到已分配的链表中。</p>
<p>注意：在分配大于1MB的内存时应该避免使用堆函数，而应该使用VirtualAlloc函数。</p>
<p>6.调整内存块大小</p>
<pre>PVOID HeapReAlloc(

     HANDLE hHeap,

     DWORD fdwFlags,

     PVOID pvMem,

     SIZE_T dwBytes);</pre>
<p>7.获得内存块大小</p>
<pre>SIZE_T HeapSize(

    HANDLE hHeap,

    DWORD fdwFlags,

    LPCVOID pvMem);</pre>
<p>8.释放内存块</p>
<pre>BOOL HeapFree(

    HANDLE hHeap,

    DWORD fdwFlags,

    PVOID pvMem);</pre>
<p>9.销毁堆</p>
<pre>BOOL HeapDestroy(HANDLE hHeap); </pre>
<p>10.其他</p>
<p>函数GetProcessHeaps返回一个HANDLE数组 &nbsp; 可获得包括默认堆在内的所有堆的句柄</p>
<p>一下两个函数要配对使用，用于线程同步：</p>
<p>BOOL HeapLock(HANDLE hHeap);</p>
<p>BOOL HeapUnlock(HANDLE hHeap);</p>
<p>让堆中闲置的内存块能重新结合在一起，并撤销调拨给堆中闲置内存块的存储器，可以调用HeapCompact：</p>
<pre>UINT HeapCompact(

    HANDLE hHeap,

    DWORD fdwFlags);</pre>
<p>HeapValidate可以验证堆的完整性。</p>
<pre>BOOL HeapValidate(

    HANDLE hHeap,

    DWORD fdwFlags,

    LPCVOID pvMem);</pre>

<pre></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-12 16:18:53 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e8%99%9a%e6%8b%9f/" title="虚拟">虚拟</a>, <a href="https://www.biecuoliao.com/tag/%e6%89%a7%e8%a1%8c/" title="执行">执行</a>, <a href="https://www.biecuoliao.com/tag/%e6%96%87%e4%bb%b6%e4%b8%ad/" title="文件中">文件中</a>, <a href="https://www.biecuoliao.com/tag/hand/" title="hand">hand</a>, <a href="https://www.biecuoliao.com/tag/%e4%ba%8c%e5%8f%89%e6%a0%91/" title="二叉树">二叉树</a>, <a href="https://www.biecuoliao.com/tag/%e8%bf%94%e5%9b%9e/" title="返回">返回</a>, <a href="https://www.biecuoliao.com/tag/%e9%87%8a%e6%94%be%e5%86%85%e5%ad%98/" title="释放内存">释放内存</a>, <a href="https://www.biecuoliao.com/tag/pcre/" title="pcre">pcre</a>, <a href="https://www.biecuoliao.com/tag/heapalloc/" title="heapalloc">heapalloc</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>进程默认堆和额外创建的堆的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NOAz8M.html" rel="bookmark">进程的虚拟地址空间，堆栈、堆、数据段、代码段</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上图是进程的虚拟地址空间示意图. 堆栈段: 1. 为函数内部的局部变量提供存储空间. 2. 进行函数调用时,存储“过程活动记录”. 3. 用作暂时存储区.如计算一个很长的算术表达式时,可以将部分计算结果压入堆栈. 数据段(静态存储区): 包括BSS段的数据段,BSS段存储未初始化的全局变量.静态变量.数据段存储经过初始化的全局和静态变量. 代码段: 又称为文本段.存储可执行文件的指令. 堆: 就像堆栈段能够根据需要自动增长一样,数据段也有一个对象,用于完成这项工作,这就是堆(heap).堆区域用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmvRon0.html" rel="bookmark">PAT 堆&mdash;&mdash;A1098&period;Insertion or Heap Sort&lpar;25&rpar;（内涵堆的详细创建过程）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				堆的详细创建过程:参考:https://www.jianshu.com/p/21bef3fc3030 明白堆的详细创建过程的前提是要理解Shift Down. 但是这明显不符合最大堆的定义,所以我们需要让该完全二叉树转换成最大堆!怎么转换成一个最大堆呢?   最大堆有一个特点就是其各个子树都是一个最大堆,那么我们就可以从把最小子树转换成一个最大堆,然后依次转换它的父节点对应的子树,直到最后的根节点所在的整个完全二叉树变成最大堆.那么从哪一个子树开始调整? 我们从该完全二叉树中的最后一个非叶子节点			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0b6Pno0.html" rel="bookmark">Java堆内存Heap与非堆内存Non-Heap</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				堆(Heap)和非堆(Non-heap)内存 按照官方的说法:&quot;Java 虚拟机具有一个堆,堆是运行时数据区域,所有类实例和数组的内存均从此处分配.堆是在 Java 虚拟机启动时创建的.&quot;&quot;在JVM中堆之外的内存称为非堆内存(Non-heap memory)&quot;.可以看出JVM主要管理两种类型的内存:堆和非堆.简单来说堆就是Java代码可及的内存,是留给开发人员使用的:非堆就是JVM留给 自己用的,所以方法区.JVM内部处理或优化所需的内存(如JIT编译后的代码缓存)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35lAQV0.html" rel="bookmark">排序 堆的实现和利用堆来排序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				*/--&gt; pre.src {background-color: Black; color: White;} pre.src {background-color: Black; color: White;} pre.src {background-color: Black; color: White;} pre.src {background-color: Black; color: White;} pre.src {background-color: Black; color: White;}			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dRpDB4.html" rel="bookmark">&lbrack;硕&period;Love Python&rsqb; FibonacciHeap&lpar;F堆 &amp; 斐波那契堆&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				class Node(object):     __slots__ = [         'data', 'child', 'left', 'right',         'degree', 'parent', 'childCut',     ]     def __init__(self, data):         self.data = data         self.child = None         self.left = None         self.right			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pGRj83.html" rel="bookmark">salt进程查看插件&amp;salt批量创建用户</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				接受key 剔除主机 ? 启动 salt-minion-d ? ? 软件包的安装 ? salt '*' state.sls init.env-init test=true ? salt批量创建用户: http://www.saltstack.cn/kb/managing-user-with-salt/#managing-user-with-salt ? 显示salt进程: http://pengyao.org/howto-display-salt-process-name.html salt进程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6g1lG0.html" rel="bookmark">数据结构&mdash;&mdash;堆（Heap）大根堆、小根堆</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Heap是一种数据结构具有以下的特点: 1)完全二叉树: 2)heap中存储的值是偏序: Min-heap: 父节点的值小于或等于子节点的值: Max-heap: 父节点的值大于或等于子节点的值: 堆的存储: 一般都用数组来表示堆,i结点的父结点下标就为(i–1)/2.它的左右子结点下标分别为2 * i + 1和2 * i + 2.如第0个结点左右子结点下标分别为1和2. 堆的操作:insert 插入一个元素:新元素被加入到heap的末尾,然后更新树以恢复堆的次序. 每次插入都是将新数据放在数组			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KBXEwM.html" rel="bookmark">通俗的比较&comma;堆主要用来存放对象的，栈主要是用来执行程序的&period;    堆内存与栈内存  &comma;&comma;堆内存与栈内存能不能共享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				创建一个对象都在内存中做了什么事情? 1:先将硬盘上指定位置的Person.class文件加载进内存.2:执行main方法时,在栈内存中开辟了main方法的空间(压栈-进栈),然后在main方法的栈区分配了一个变量p.3:在堆内存中开辟一个实体空间,分配了一个内存首地址值.new4:在该实体空间中进行属性的空间分配,并进行了默认初始化.5:对空间中的属性进行显示初始化.6:进行实体的构造代码块初始化.7:调用该实体对应的构造函数,进行构造函数初始化.()8:将首地址赋值给p ,p变量就引用了该实			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0l7KgpM.html" rel="bookmark">堆的首地址和堆的指针</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 #include &quot;stdafx.h&quot; 2 #include &quot;iostream&quot; 3 4 using namespace std; 5 6 class CStu 7 { 8 private: 9 int M_Id; 10 int M_Age; 11 public: 12 void set(int x) 13 { 14 M_Id = x; 15 } 16 17 }; 18 19 int main(int argc, char* argv[]) 20 { 21 C			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n0lz5p4.html" rel="bookmark" class="title">GROUP BY语句与HAVING语句的使用</a>
					<div>
						一.GROUP BY GROUP BY语句用来与聚合函数(aggregate functions such as COUNT, SUM, AVG, MIN, or MAX.)联合使用来得到一个或多个列 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/7MVLWd3.html" rel="bookmark" class="title">表达式拼接Expression&amp;lt&semi;Func&amp;lt&semi;IEntityMapper&comma; bool&amp;gt&semi;&amp;gt&semi; predicate</a>
					<div>
						/// &lt;summary&gt; /// 重写以筛选出当前上下文的实体映射信息 /// &lt;/summary&gt; protected override IEnumerable&lt;IE ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r4J7A9M.html" rel="bookmark" class="title">深入理解java虚拟机一 JAVA运行时内存区域与class文件</a>
					<div>
						一 JAVA运行时内存区域 JVM在加载class文件时,会将class文件定义的数据结构转为运行时内存中的数据,那么jvm是如何安排运行时的内存区域呢? jvm将运行时内存划分为以下几个部分: 堆: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q3qy6a3.html" rel="bookmark" class="title">蓝桥杯 地宫取宝（12&amp;&num;39&semi;）</a>
					<div>
						X 国王有一个地宫宝库.是n x m 个格子的矩阵.每个格子放一件宝贝.每个宝贝贴着价值标签. 地宫的入口在左上角,出口在右下角. 小明被带到地宫的入口,国王要求他只能向右或向下行走. 走过某个格子时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M68Nov3.html" rel="bookmark" class="title">VFS分析&lpar;一&rpar;挂载&lpar;持续更新&rpar;</a>
					<div>
						基础知识在&lt;深入linux内核架构&gt;第8章,自行脑补. 看下几个关键的过程: do_add_mount里有重要函数lock_mount, lock_mount函数的输入是struct pa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGG8ZyM.html" rel="bookmark" class="title">HDOJ&colon; 5596</a>
					<div>
						从前,有nn只萌萌的GT,他们分成了两组在一起玩游戏.他们会排列成一排,第ii只GT会随机得到一个能力值bib?i??.在第ii秒的时候,第ii只GT可以消灭掉所有排在他前面的和他不是同一组的且能力值 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YG8PJ4.html" rel="bookmark" class="title">6&period;1、索引--Oracle模式对象</a>
					<div>
						1.创建索引: (1).单列索引 Create index name_index on 门诊费用记录(id) (2).复合索引 同一张表可以有多个索引,但是要求列的组合必须不同, --例如: Crea ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35q5ZV3.html" rel="bookmark" class="title">ubuntu 安装vagrant过程</a>
					<div>
						Ubuntu安装vagrant时需要首先安装virtualBox. Step1: 在https://www.virtualbox.org/wiki/Linux_Downloads 下载ubuntu对应 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38Lnag3.html" rel="bookmark" class="title">RHEL5&period;8 ext3文件系统损坏的只检测不修复&lpar;fsck -n&rpar;</a>
					<div>
						[[email protected] ~]# df -Th Filesystem Type Size Used Avail Use% Mounted on /dev/mapper/VolGroup00 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVVnNpM.html" rel="bookmark" class="title">Java描述符的类型</a>
					<div>
						以下内容引用自http://wiki.jikexueyuan.com/project/java/modifier-types.html: 描述符(修饰符)是你添加到那些定义中来改变他们的意思的关键词. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nYwwpM.html" rel="bookmark" class="title">oracle 卡住不动</a>
					<div>
						SUSE 11 SP2 装 ORACLE 11g遇到的小问题: 1. 在 database目录里面运行 ./runInstall,之后,出现图形界面,然后点下一步,下一步,到了第3个或者第4个界面,就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZenX3.html" rel="bookmark" class="title">OC NSNumber NSInteger 直接赋值问题</a>
					<div>
						一 问题描述 类对象的属性id类型是NSNumber ,设置UI 的 tag(NSInteger类型)时候,数据失真. id属性是1,tag 取出来为19. 1.1 UI tag 属性 // @pro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmYmKDM.html" rel="bookmark" class="title">Word 主控文档与子文档（免费课程资料）</a>
					<div>
						课程简介:Word中的主控文档与子文档这个功能,对于大部分人来说,应该是不太了解的,不了解就更谈不上应用了.这也是制作这个视频课程的目的,希望更多的人能够了解并在需要时能真正应用到工作中.那在什么时候 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49LvpD3.html" rel="bookmark" class="title">magento获取商品的图片</a>
					<div>
						获取商品的图片主要从catalog_product_entity_media_gallery 表中 该表中各列的属性代表 value_id:记录 ID,可以留空让数据库自动生成. attribute_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBbYnKM.html" rel="bookmark" class="title">FLASH驱动之-块设备驱动系统构架</a>
					<div>
						一.  块设备是只能以块为单位进行访问的设备,块的大小一般是512个字节的整数倍,常见的块设备包括硬件,SD卡,光盘,flash等.驱动程序是块的整数倍从设备读写得到数据.块设备的最小访单位为块,不同 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXqoN80.html" rel="bookmark" class="title">JavaScript补充：BOM（浏览器对象模型）</a>
					<div>
						一些公共对象.详细参考手册. 一.Window 对象 Window 对象表示浏览器中打开的窗口. 如果文档包含框架(&lt;frame&gt; 或 &lt;iframe&gt; 标签),浏览器会为 H ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xajkn3.html" rel="bookmark" class="title">XManager与Linux上的设置</a>
					<div>
						打开XManager中的Xmanager-Passive 在Linux主机上设置如下: export DISPLAY=192.168.56.101:0.0 xhost +					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35r9z14.html" rel="bookmark" class="title">核心动画中的几种layer</a>
					<div>
						第10章其他有用的层 免责申明(必读!):本博客提供的所有教程的翻译原稿均来自于互联网,仅供学习交流之用,切勿进行商业传播.同时,转载时不要移除本申明.如产生任何纠纷,均与本博客所有人.发表该翻译稿之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wBznl0.html" rel="bookmark" class="title">Eclipse从零配置Maven环境 笔记</a>
					<div>
						Eclipse配置maven环境笔记 转载请注明:http://blog.csdn.net/kisssun0608/ 1.      下载maven http://maven.apache.org/d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wBw6j0.html" rel="bookmark" class="title">Android学习启动篇--eclipse如何调试system&lowbar;server</a>
					<div>
						打算开始Android系统学习,君预善其事,必先利其器.如果能够在eclipse中调试system_server, 对于理解Android系统服务能够起到很大的帮助. 在网上查了点资料,基本上都比较麻 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
